%define name gcc
%define version 2.7.2.3
%define release 11

Summary: GNU C Compiler
Name: %{name}
Version: %{version}
Release: %{release}
Copyright: GPL
Group: Development/Languages
Source: ftp://prep.ai.mit.edu/pub/gnu/gcc-%{version}.tar.gz
Source1: gcc-c-skel 
Source2: gcc-c++-skel 
Source3: gcc-objc-skel
Patch0: sunsite.unc.edu:/pub/Linux/GCC/gcc-2.7.2-linux.diff.gz
Patch1: gcc-2.7.2-make.patch
Patch2: gcc-2.7.2.sparc.patch
Patch3: ftp://atheist.tamu.edu/pub/richard/linux/axp/rth-gcc-2.7.2-960814.diff.gz
Patch4: gcc-2.7.2-pg.patch
Patch5: gcc-2.7.2-flow.patch
Patch6: ftp://ftp.redhat.com/pub/alphabits/rth-gcc-2.7.2-961121.diff.gz
Patch7: gcc-2.7.2.sparc.patch2
Patch8: gcc-2.7.2.3-glibc2.patch
Patch9: gcc-2.7.2-alpha-ra.patch
Patch10: gcc-2.7.2.2-060.diff
Patch11: gcc-2.7.2-reg-alloc.patch
Requires: binutils
Prereq: /sbin/install-info
Buildroot: /var/tmp/gcc-root
Distribution: fatrat
Packager: Frank Meurer <meurer@gmx.de>
Exclusivearch: i386 m68k
Summary(de): GNU-C-Compiler 
Summary(fr): Compilateur C de GNU
Summary(tr): GNU C derleyicisi

%changelog
* Tue Oct  2 2001 Frank Meurer <meurer@gmx.de>
- rebuild RedHat 4.2 for Linux/m68k

* Mon Feb 28 2000 meurer@gmx.de
- compile on mac68k

* Thu May 07 1998 Prospector System <bugs@redhat.com>

- translations modified for de, fr, tr

* Thu Apr 30 1998 Cristian Gafton <gafton@redhat.com>
- use extensively CFLAGS="-O2" when building the compiler (this is known to
  help the fully compatible Cyrix chips (sic!) to run this beast)

* Mon Apr 20 1998 Cristian Gafton <gafton@redhat.com>
- better yet, ExclusiveArch: i386 is in effect

* Tue Apr 14 1998 Cristian Gafton <gafton@redhat.com>
- removed the c++ package as we are switching to egcs-c++
- idem for objc
- added buildroot
- alpha is exlcuded from the build. I don't know about sparc yet, so I leave
  it for this time

* Fri Oct 23 1997 Erik Troan <ewt@redhat.com>
- use ld-linux.so.2 on the sparc

* Fri Oct 10 1997 Erik Troan <ewt@redhat.com>
- build crtbegin* and crtend* on the sparc

* Mon Sep 29 1997 Erik Troan <ewt@redhat.com>
- added patch from rth to fix dump on alpha w/ building libg++

* Sun Sep 28 1997 Erik Troan <ewt@redhat.com>
- djb really made the crtbegin/end stuff in gcc-c-skel conditional on
  running on an i386 machine, not a !sparc machine; all changed was his
  comment
- added patch to use /lib/ld-linux.so.2 on the alpha

* Tue Sep 23 1997 Richard Henderson <rth@cygnus.com>
- Killed the glibc.patch and added sparc.patch2 to _really_ make
  libgcc.a be compiled with -fPIC.

* Fri Sep 19 1997 Donald Barnes <djb@redhat.com>
- added the glibc.patch so that libgcc.a is compiled with -fPIC
- added %ifarch i386 around crtbegin/end in gcc-c-skel

* Sun Sep 14 1997 Erik Troan <ewt@redhat.com>
- modified to use install-info

* Sun Aug 24 1997 Erik Troan <ewt@redhat.com>
- updated to gcc 2.7.2.3

* Thu Aug 21 1997 Erik Troan <ewt@redhat.com>
- fixed /lib/cpp patch to include redhat element

* Mon Jun 02 1997 Erik Troan <ewt@redhat.com>
- removed HJ's patch
- added patch from Ulrich Drepper to generate crt*.o

%description
The GNU C compiler -- a full featured ANSI C compiler, with support
for K&R C as well. GCC provides many levels of source code error
checking tradionaly provided by other tools (such as lint), produces
debugging information, and can perform many different optimizations to
the resulting object code. This contains the back end for C++ and 
Objective C compilers as well.

%description -l de
Der GNU-C-Compiler, ein ANSI-C-Compiler mit komplettem Funktions-
umfang sowie Untersttzung fr K&R. GCC bietet viele Ebenen der
Quell-Code-Fehlerprfung, wie sie frher durch separate Tools bereitgestellt
wurde (etwa lint), produziert Debug-Infos und ist in der Lage, viele
verschiedene Optimierungen am resultierenden Objektcode auszufhren. 
Enthlt auch das Backend fr C++ und Objective-C-Compiler.

%description -l fr
Le compilateur C GNU -- un compilateur C ANSI complet, avec un support
pour la norme K&R. GCC fournit de nombreux niveaux d'erreurs donns par
des outils extrieurs (comme lint), produit des informations de dbogage,
et peut raliser diffrentes optimisations sur le code objet produit.
Il contient aussi le back-end pour les compilateurs Objective C et C++.

%description -l tr
GNU C derleyicisi, K&R C destei olan ve ANSI C'nin btn zelliklerine sahip
bir derleyicidir. Normalde baka aralarn (rnein lint) yapt kaynak kodu
dzeyindeki pek ok hata denetimini gerekletirir, hata ayklama bilgisi
retebilir ve sonu olarak ortaya kan ara kod zerinde birok optimizasyon
uygulayabilir.

%package c++
Summary: C++ support for gcc
Group: Development/Languages
Requires: gcc = %{version}

%description c++
This package adds C++ support to the GNU C compiler. It includes support
for most of the current C++ specification, including templates and
exception handling. It does not include a standard C++ library, which
is available separately.

%package objc
Requires: gcc = %{version}
Summary: Objective C support for gcc
Group: Development/Languages

%description objc
This package adds Objective C support to the GNU C compiler. Objective
C is a object oriented derivative of the C language, mainly used on
systems running NeXTSTEP. This package does not include the standard
objective C object library.

%prep
%setup -q
%patch1 -p1 -b .rh

%ifarch sparc alpha
%patch2 -p1
%patch3 -p1
%patch4 -p0
%patch5 -p1
%patch6 -p1
%patch7 -p1
%patch8 -p1 -b .glibc2
%patch9 -p0 -b .alphara
%endif

%ifarch m68k
%patch2 -p1
%patch3 -p1
%patch4 -p0
%patch5 -p1
%patch6 -p1
%patch7 -p1
%patch9 -p0 -b .alphara

%patch10 -p1
%patch11 -p0
%endif

for n in gcc-c-skel gcc-c++-skel gcc-objc-skel; do
    sed "s/ARCH-/${RPM_ARCH}-fatrat-/g" < $RPM_SOURCE_DIR/$n | \
	sed "s/VERSION/${RPM_PACKAGE_VERSION}/g" > $n
done

%build
./configure --prefix=/usr \
	--local-prefix=/usr/local --gxx-include-dir=/usr/include/g++ \
	${RPM_ARCH}-fatrat-linux 

%ifarch m68k
# we actually don't *need* the flags but we set it
make LANGUAGES=c CFLAGS="-O2 -m68030 -m68881 -fomit-frame-pointer"
export LANGUAGES="c c++ objective-c proto"
make stage1
make CC="stage1/xgcc -Bstage1/" CFLAGS="-O2 -m68030 -m68881 -fomit-frame-pointer" LDFLAGS="-s"
make stage2
make CC="stage2/xgcc -Bstage2/" CFLAGS="-O2 -m68030 -m68881 -fomit-frame-pointer" LDFLAGS="-s"
# For Objective C only
make objc-runtime CC="stage2/xgcc -Bstage2/" CFLAGS="-O2 -m68030 -m68881 -fomit-frame-pointer" LDFLAGS="-s"
%else
make LANGUAGES=c CFLAGS="-O2"
export LANGUAGES="c c++ objective-c proto"
make stage1
make CC="stage1/xgcc -Bstage1/" CFLAGS="-O2" LDFLAGS="-s"
make stage2
make CC="stage2/xgcc -Bstage2/" CFLAGS="-O2" LDFLAGS="-s"
# For Objective C only
make objc-runtime CC="stage2/xgcc -Bstage2/" CFLAGS="-O2" LDFLAGS="-s"
%endif

%install
rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT/{lib,usr/{bin,lib,info,man}}
%ifarch m68k
make CC="stage2/xgcc -Bstage2/" CFLAGS="-O2 -m68030 -m68881 -fomit-frame-pointer" LDFLAGS="-s" install \
	prefix=$RPM_BUILD_ROOT/usr
# For Objective C only
make install-libobjc CC="stage2/xgcc -Bstage2/" CFLAGS="-O2 -m68030 -m68881 -fomit-frame-pointer" LDFLAGS="-s" \
	prefix=$RPM_BUILD_ROOT/usr
%else
make CC="stage2/xgcc -Bstage2/" CFLAGS="-O2" LDFLAGS="-s" install \
	prefix=$RPM_BUILD_ROOT/usr
# For Objective C only
make install-libobjc CC="stage2/xgcc -Bstage2/" CFLAGS="-O2" LDFLAGS="-s" \
	prefix=$RPM_BUILD_ROOT/usr
%endif

#rm -f $RPM_BUILD_ROOT/usr/info/cpp.info* $RPM_BUILD_ROOT//usr/info/dir
gzip -n -9f $RPM_BUILD_ROOT/usr/info/gcc.info* $RPM_BUILD_ROOT/usr/info/cpp.info*
ln -sf gcc $RPM_BUILD_ROOT/usr/bin/cc
ln -sf cccp.1 $RPM_BUILD_ROOT/usr/man/man1/cpp.1
ln -sf ../usr/lib/gcc-lib/${RPM_ARCH}-fatrat-linux/${RPM_PACKAGE_VERSION}/cpp $RPM_BUILD_ROOT/lib/cpp
ln -sf ${RPM_ARCH}-fatrat-linux $RPM_BUILD_ROOT/usr/lib/gcc-lib/${RPM_ARCH}-linux
ln -sf ${RPM_ARCH}-fatrat-linux $RPM_BUILD_ROOT/usr/lib/gcc-lib/${RPM_ARCH}-unknown-linux
#rm -rf $RPM_BUILD_ROOT/usr/lib/gcc-lib/${RPM_ARCH}-fatrat-linux/*/include/objc

%post
/sbin/install-info /usr/info/gcc.info.gz /usr/info/dir --entry="* gcc: (gcc).                   The GNU C compiler."

%preun
if [ $1 = 0 ]; then
    /sbin/install-info --delete /usr/info/gcc.info.gz /usr/info/dir --entry="* gcc: (gcc).                   The GNU C compiler."
fi

%files -f gcc-c-skel
%doc NEWS PROBLEMS
%dir /usr/lib/gcc-lib
/usr/bin/gcc
/usr/bin/cc
/usr/bin/protoize
/usr/bin/unprotoize

/lib/cpp

/usr/man/man1/cpp.1*
/usr/man/man1/cccp.1*
/usr/man/man1/gcc.1*

/usr/info/cpp.info*
/usr/info/gcc.info*

/usr/lib/gcc-lib/m68k-fatrat-linux/%{version}/crtbegin.o
/usr/lib/gcc-lib/m68k-fatrat-linux/%{version}/crtbeginS.o
/usr/lib/gcc-lib/m68k-fatrat-linux/%{version}/crtend.o
/usr/lib/gcc-lib/m68k-fatrat-linux/%{version}/crtendS.o
/usr/lib/gcc-lib/m68k-linux
/usr/lib/gcc-lib/m68k-unknown-linux

%files c++ -f gcc-c++-skel

%files objc -f gcc-objc-skel

%clean
#rm -rf $RPM_BUILD_ROOT
